SystemOrganization addCategory: #'Math-Tests-ODE'!

TestCase subclass: #AB2SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AB2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:31'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo: 1.1237].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4) closeTo:  -0.2451).
! !

!AB2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:31'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1  ) closeTo: 2.1875].
	self should: [(  solver solve: system startState: 1.25 startTime: 0.5 endTime: 2  ) closeTo: 17.4512].
! !

!AB2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 16:14'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [((   solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((   solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #AB2StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AB2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/10/2013 12:05'!
testOrderIsTwo
	self should: [AB2Stepper order = 2]
! !

!AB2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/15/2013 15:42'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | t sin].
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].
	! !

!AB2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:33'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo: 3.6756].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.28534).! !

!AB2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:34'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.25].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1) closeTo: 2.4219].
	self should: [(solver solve: system startState: 2.4219 startTime: 0.5 endTime: 1) closeTo: 4.6924].! !

TestCase subclass: #AB3SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AB3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 12:25'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo: 1.1237].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4) closeTo:  -0.2451).! !

!AB3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 11:10'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1.7  ) closeTo: 10.8633].
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1  ) closeTo: 2.1875].
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1.5  ) closeTo: 5.546875].! !

!AB3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 11:10'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.001.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [((   solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1  ) closeTo: 1].
	self should: [((   solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #AB3StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AB3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:29'!
testOrderIsThree
	self should: [AB3Stepper order = 3]! !

!AB3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 13:03'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | t sin].
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!AB3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 11:10'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper :=AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo: 3.67565].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.28534).! !

!AB3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 11:10'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.25].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1) closeTo: 2.4219].
	self should: [(solver solve: system startState: 2.4219 startTime: 0.5 endTime: 1) closeTo: 4.6924].! !

TestCase subclass: #AB4SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AB4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/2/2013 16:46'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo: 1.1237].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4) closeTo:  -0.2451).! !

!AB4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 16:13'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1  ) closeTo: 2.1875].
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1.5  ) closeTo: 5.546875].
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 1.7  ) closeTo: 11.4082].
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 2.0  ) closeTo: 20.2002].
	self should: [(  solver solve: system startState: 1 startTime: 0 endTime: 2.5  ) closeTo: 95.5152].
	! !

!AB4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/2/2013 16:45'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.001.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [((   solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1  ) closeTo: 1].
	self should: [((   solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #AB4StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AB4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/2/2013 14:42'!
testOrderIsFour
	self should: [AB4Stepper order = 4]! !

!AB4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 13:03'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | t sin].
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!AB4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/2/2013 16:44'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper :=AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo: 3.67565].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.28534).! !

!AB4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/2/2013 16:43'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.25].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1) closeTo: 2.4219].
	self should: [(solver solve: system startState: 2.4219 startTime: 0.5 endTime: 1) closeTo: 4.6924].! !

TestCase subclass: #AM3SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AM3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/15/2013 18:42'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  2.8978).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo: 0.8577).! !

!AM3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/15/2013 17:03'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 9.7551].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.5) closeTo:9.7298].
	self should: [(solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo: 0].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 2.5) closeTo:415.6194].! !

!AM3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 12:58'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #AM3StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AM3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 13:20'!
testOrderIsThree
	self should: [AM3Stepper order = 3]! !

!AM3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 13:05'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | t sin].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!AM3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 18:22'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.7) closeTo: 4.5912).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo: 4.9614).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3.0) closeTo:  2.8977).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4.0) closeTo:  0.5375).! !

!AM3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 18:21'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.3125].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.3) closeTo: 6.7429].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.3) closeTo: 6.76035].! !

!AM3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/15/2013 18:53'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #AM4SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AM4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:25'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  2.6231).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.8577).! !

!AM4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:24'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 15.2741].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 2.2) closeTo: 191.3011].
	self should: [(solver solve: system startState: 0.5 startTime: 1 endTime: 2.5) closeTo: 112.8325].
	self should: [(solver solve: system startState: 0.5 startTime: 1 endTime: 2.8) closeTo: 535.8236].! !

!AM4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 13:01'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #AM4StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!AM4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 13:20'!
testOrderIsFour
	self should: [AM4Stepper order = 4]! !

!AM4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 13:11'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | t sin].
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!AM4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:31'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.7) closeTo:  4.5912).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo:  4.9614).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3.0) closeTo:  2.6231).
       self should: ((solver solve: system startState: 0.1 startTime: 2 endTime: 4.1) closeTo:  0.2908).! !

!AM4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:33'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.3125].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.3) closeTo: 6.7429].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.3) closeTo: 	9.6147].! !

TestCase subclass: #BDF2SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!BDF2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 16:00'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  0.54985).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  -0.5306).! !

!BDF2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/6/2013 23:31'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 11.9167].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.5) closeTo:9.5833].
	self should: [(solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo: 21.9166].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 2.5) closeTo:273.7129].! !

!BDF2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/10/2013 15:51'!
testSolveStartStateStartTimeEndTimeStepSize
	| solver stepper system dt finalState |
	dt := 0.2.
	system := ImplicitSystem block: [:x :t | (t * x ) exp].
	stepper := ImplicitStepper onSystem: system.
	stepper stepSize: dt.
	solver := (BDF2Solver new 
				system: system; 
				stepper: stepper).
	finalState := solver solve: solver system startState: 0 startTime: 0  endTime: 1 stepSize: dt. 
	self should: [finalState isFloat].
	
	"Debgging information"
	Transcript 
		show: self class name asByteString;  cr; 
		show: system block asText ; cr;
		show: 'from x(0) = 0 to x(1) = ';
		show: finalState; cr;
		show: 'with stepSize = ', solver dt printString; cr.! !

!BDF2SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/10/2013 15:49'!
testSolveX0T0T1
	| solver stepper system dt finalState |
	dt := 0.1.
	system := ImplicitSystem block: [:x :t | (t * x ) exp].
	stepper := ImplicitStepper onSystem: system.
	stepper stepSize: dt.
	solver := (BDF2Solver new 
				system: system; 
				stepper: stepper;
				dt: dt).
	finalState := solver solve: solver system startState: 0 startTime: 0  endTime: 1. 
	self should: [finalState isFloat].
	
	"Debgging information"
	Transcript 
		show: self class name asByteString;  cr; 
		show: system block asText ; cr;
		show: 'from x(0) = 0 to x(1) = ';
		show: finalState; cr;
		show: 'with stepSize = ', solver dt printString; cr.! !

TestCase subclass: #BDF2StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!BDF2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/10/2013 12:06'!
testOrderIsTwo
	self should: [BDF2Stepper order = 2]! !

!BDF2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 11:59'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | t sin].
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!BDF2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 15:33'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.7) closeTo:  1.10147).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo:  2.10409).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3.0) closeTo:  0.54985).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4.0) closeTo:  -0.71539).
	! !

!BDF2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 20:17'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.2) closeTo: 1.75].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.75].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.3) closeTo: 6.0793].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.3) closeTo: 	7.5367].! !

!BDF2StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/5/2013 16:13'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.0001.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #BDF3SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!BDF3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/6/2013 15:34'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  0.54985).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  -0.5306).! !

!BDF3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 14:17'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 11.0227].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 2.5) closeTo:219.4525].
	self should: [(solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo: 19.4318].
	self should: [(solver solve: system startState: 0 startTime: 1 endTime: 2.8) closeTo: 73.5867].! !

!BDF3SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 12:50'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #BDF3StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!BDF3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/6/2013 15:32'!
testOrderIsThree
	self should: [BDF3Stepper order = 3]! !

!BDF3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 15:40'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | t sin].
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [( solver solve: system startState: -1 startTime: 0 endTime: Float pi ) closeTo: 1].! !

!BDF3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/6/2013 15:32'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.7) closeTo:  1.10147).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo:  2.10409).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3.0) closeTo:  0.54985).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4.0) closeTo:  -0.71539).! !

!BDF3StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/6/2013 22:53'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.75].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.3) closeTo: 6.0793].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.3) closeTo: 	7.4391].! !

TestCase subclass: #BDF4SolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!BDF4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 16:11'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  2.5637).
      self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.4395).
	self should: ((solver solve: system startState: 0 startTime: 0 endTime: 3) closeTo:  1.0793).! !

!BDF4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 14:55'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 0.25 startTime: 0.5 endTime: 2.0) closeTo: 13.4091].
	self should: [(solver solve: system startState: 0.25 startTime: 0.5 endTime: 2.3) closeTo: 41.21625].
	self should: [(solver solve: system startState: 0.25 startTime: 0.5 endTime: 2.5) closeTo: 69.9482].
	self should: [(solver solve: system startState: 0 startTime: 1 endTime: 2.8) closeTo: 71.9236].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 11.0227].! !

!BDF4SolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 14:18'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [(  (solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #BDF4StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!BDF4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 14:18'!
testOrderIsFour
	self should: [BDF4Stepper order = 4]! !

!BDF4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 16:07'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | t sin].
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [( solver solve: system startState: -1 startTime: 0 endTime: Float pi ) closeTo: 1].! !

!BDF4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 16:09'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo:  4.03597).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.7) closeTo:  3.6812).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 2.0) closeTo: 3.5316).
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3.0) closeTo:  2.5637).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 4.0) closeTo:  0.35925).! !

!BDF4StepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/8/2013 14:47'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.75].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.0) closeTo: 3.75].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 	11.0227].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 2.0) closeTo: 	43.2181].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 2.3) closeTo: 	132.2771].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 2.5) closeTo: 	224.881].! !

TestCase subclass: #ExplicitSolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!ExplicitSolverTest commentStamp: '<historical>' prior: 0!
An ODESolverTest is a test class for testing the behavior of ODESolver!

!ExplicitSolverTest methodsFor: 'tests-solving' stamp: 'NataliaMoskovchuk 7/26/2013 16:37'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(  solver solve: system startState: 5 startTime: 0 endTime: 1.5  ) closeTo: 4.30204].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.5158).! !

!ExplicitSolverTest methodsFor: 'tests-solving' stamp: 'NataliaMoskovchuk 7/15/2013 15:47'!
testSolveStartStateStartTimeEndTimeStepSize
	| solver stepper system dt finalState |
	dt := 0.2.
	system := ExplicitSystem block: [:x :t | (t * x ) exp].
	stepper := ExplicitStepper onSystem: system.
	stepper stepSize: dt.
	solver := (ExplicitSolver new 
				system: system; 
				stepper: stepper).
	finalState := solver solve: solver system startState: 0 startTime: 0  endTime: 1 stepSize: dt. 
	self should: [finalState isFloat].
	
	"Debgging information"
	Transcript 
		show: self class name asByteString;  cr; 
		show: system block asText ; cr;
		show: 'from x(0) = 0 to x(1) = ';
		show: finalState; cr;
		show: 'with stepSize = ', solver dt printString; cr.! !

!ExplicitSolverTest methodsFor: 'tests-solving' stamp: 'NataliaMoskovchuk 7/15/2013 15:48'!
testSolveX0T0T1
	| solver stepper system dt finalState |
	dt := 0.1.
	system := ExplicitSystem block: [:x :t | (t * x ) exp].
	stepper := ExplicitStepper onSystem: system.
	stepper stepSize: dt.
	solver := (ExplicitSolver new 
				system: system; 
				stepper: stepper;
				dt: dt).
	finalState := solver solve: solver system startState: 0 startTime: 0  endTime: 1. 
	self should: [finalState isFloat].
	
	"Debgging information"
	Transcript 
		show: self class name asByteString;  cr; 
		show: system block asText ; cr;
		show: 'from x(0) = 0 to x(1) = ';
		show: finalState; cr;
		show: 'with stepSize = ', solver dt printString; cr.! !

TestCase subclass: #ExplicitStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!ExplicitStepperTest commentStamp: '<historical>' prior: 0!
An ExplicitStepperTest is a test class for testing the behavior of ExplicitStepper!

!ExplicitStepperTest methodsFor: 'tests-stepping' stamp: 'NataliaMoskovchuk 7/23/2013 20:48'!
testDoStepTime
	"this is identical to testDoStepTimeStepSize except dt is stored."
	| stepper sys dt |
	sys := ExplicitSystem block: [:x :t | x * t].
	stepper := ExplicitStepper onSystem: sys.
	dt := 0.1.
	stepper stepSize: dt.
	self should: [stepper stepSize = dt].
	self should: [(stepper doStep: 0 time: 10) = 0 ].
	self should: [(stepper doStep: 10 time: 0 stepSize: 1) = 10 ].

	"stepSize parameter changes the stored stepSize"
	self should: [(stepper stepSize = 1)].

	self should: [(stepper doStep: 1 time:  1) = 2].
	self should: [(stepper doStep: 10 time:  1 stepSize: 0.2) = 12.0].! !

!ExplicitStepperTest methodsFor: 'tests-stepping' stamp: 'DanielUber 5/22/2012 10:59'!
testDoStepTimeStepSize
	| stepper sys dt |
	sys := ExplicitSystem block: [:x :t | x * t].
	stepper := ExplicitStepper onSystem: sys.
	dt := 0.1.
	self should: [(stepper doStep: 0 time: 10 stepSize: dt) = 0 ].
	self should: [(stepper doStep: 10 time: 0 stepSize: dt) = 10 ].
	self should: [(stepper doStep: 1 time:  1 stepSize: dt) = 1.1].
	self should: [(stepper doStep: 10 time:  1 stepSize: dt) = 11.0].! !

!ExplicitStepperTest methodsFor: 'tests-stepping' stamp: 'DanielUber 5/22/2012 11:02'!
testOrderOfBaseExplicitStepperIsOne
	| order |
	order := ExplicitStepper new order.
	self should: [order notNil].
	self should: [order = 1].! !

!ExplicitStepperTest methodsFor: 'tests-stepping' stamp: 'NataliaMoskovchuk 7/23/2013 20:50'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := ExplicitStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1.0049].! !

TestCase subclass: #HeunStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!HeunStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/24/2013 13:09'!
testOrderIsTwo
	self should: [HeunStepper order = 2]! !

!HeunStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/24/2013 13:15'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | t sin].
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [( solver solve: system startState: -1 startTime: 0 endTime: Float pi ) closeTo: 1].! !

!HeunStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 14:14'!
testSimpleSystem2

	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(  solver solve: system startState: 5 startTime: 0 endTime: 0.5  ) closeTo: 5.15489].
	self should: ((  solver solve: system startState: 0 startTime: 1 endTime: 1.5  ) closeTo: 0.3881).! !

!HeunStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/24/2013 14:07'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [( solver solve: system startState: 1 startTime: 0 endTime: 0.5 ) closeTo: 1.25].
	self should: [(  solver solve: system startState: 1.25 startTime: 0.5 endTime: 1 ) closeTo: 2.5].! !

!HeunStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/24/2013 13:11'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #ImplMidpointSolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!ImplMidpointSolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:38'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := ImplMidpointStepper onSystem: system.
	solver := (ImplMidpointSolver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  4.9733).
       self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo: 0.8242).! !

TestCase subclass: #ImplMidpointStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!ImplMidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/12/2013 08:44'!
testOrderIsTwo
	self should: [ImplMidpointStepper order = 2]! !

!ImplMidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/23/2013 12:55'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | t sin].
	stepper := ImplMidpointStepper onSystem: system.
	solver := (ImplMidpointSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!ImplMidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:39'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := ImplMidpointStepper onSystem: system.
	solver := (ImplMidpointSolver new) stepper: stepper; system: system; dt: dt.
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo:  5.9805).
      self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.8242).! !

!ImplMidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 14:15'!
testSimpleSystem3
	
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := ImplMidpointStepper onSystem: system.
	solver := (ImplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1) closeTo: 2.6348].! !

!ImplMidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/23/2013 21:30'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ImplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := ImplMidpointStepper onSystem: system.
	solver := (ImplMidpointSolver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #ImplicitStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!ImplicitStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 13:40'!
testDoStepTime
	"this is identical to testDoStepTimeStepSize except dt is stored."
	| stepper sys dt |
	sys := ImplicitSystem block: [:x :t | x * t].
	stepper := ImplicitStepper onSystem: sys.
	dt := 0.1.
	stepper stepSize: dt.
	self should: [stepper stepSize = dt].
	self should: [(stepper doStep: 0 time: 10) = 0.101 ].
	self should: [(stepper doStep: 10 time: 0 stepSize: 1) = 21].

	"stepSize parameter changes the stored stepSize"
	self should: [(stepper stepSize = 1)].

	self should: [(stepper doStep: 1 time:  1) = 5].
	self should: [(stepper doStep: 10 time:  1 stepSize: 0.2) = 12.448].! !

!ImplicitStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 13:41'!
testDoStepTimeStepSize
	| stepper sys dt |
	sys := ImplicitSystem block: [:x :t | x * t].
	stepper := ImplicitStepper onSystem: sys.
	dt := 0.1.
	self should: [(stepper doStep: 0 time: 10 stepSize: dt) = 0.101 ].
	self should: [(stepper doStep: 10 time: 0 stepSize: dt) = 10.101 ].
	self should: [(stepper doStep: 1 time:  1 stepSize: dt) = 1.121].
	self should: [(stepper doStep: 10 time:  1 stepSize: dt) = 11.111].! !

TestCase subclass: #MidpointStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!MidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 4/21/2013 16:26'!
testOrderIsTwo
	self should: [MidpointStepper order = 2]! !

!MidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/15/2013 15:47'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | t sin].
	stepper := MidpointStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].! !

!MidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:40'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := MidpointStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo: 3.6756].
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo: 2.3049].
	! !

!MidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:40'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ExplicitSystem block: [:x :t | 2 * t * x].
	stepper := MidpointStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 0.5) closeTo: 1.25].
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1) closeTo: 2.4219].! !

!MidpointStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/15/2013 15:46'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := MidpointStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #ODESystemTest
	instanceVariableNames: 'sys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!ODESystemTest commentStamp: '<historical>' prior: 0!
An ODESystemTest is a test class for testing the behavior of ODESystem!

!ODESystemTest methodsFor: 'running' stamp: 'NataliaMoskovchuk 7/3/2013 23:29'!
setUp
	"create a dummy system"
	sys := ODESystem new.! !

!ODESystemTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 10:15'!
testBlock
	| aBlock |
	aBlock := [:x : t | t].
	sys block: aBlock.
	self should: [sys block = aBlock].! !

!ODESystemTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 11:29'!
testVectorBlock
	"this illustrates using a block that operates on a collection"
	| aBlock |
	aBlock := [:x : t | x collect: [:ea | t]].
	sys block: aBlock.
	self should: [sys block = aBlock].! !

!ODESystemTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 11:28'!
testVectorXT
	"a simple example of using a collection as state"
	| aBlock |
	aBlock := [:x : t | x collect: [:ea | t]].
	sys block: aBlock.
	self should: [(sys x: #(1 2 3) t: 2 ) = #(2 2 2)].
	self should: [(sys x: #(0 0) t: 2) = #(2 2)].
! !

!ODESystemTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 10:16'!
testXT
	| aBlock |
	aBlock := [:x : t | t].
	sys block: aBlock.
	self should: [(sys x: 1 t: 2 ) = 2].
	self should: [(sys x: 0 t: 2) = 2].
! !

TestCase subclass: #RungeKuttaStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!RungeKuttaStepperTest methodsFor: 'as yet unclassified' stamp: 'DanielUber 6/4/2012 09:15'!
testOrderIsFour
	self should: [RungeKuttaStepper order = 4].! !

!RungeKuttaStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/15/2013 15:49'!
testSimpleSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | t sin].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: -1 startTime: 0 endTime: Float pi) closeTo: 1].
	! !

!RungeKuttaStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/26/2013 16:41'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ExplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 5 startTime: 0 endTime: 1.5) closeTo: 4.3646].
	self should: ((solver solve: system startState: 0 startTime: 1 endTime: 2.5) closeTo:  0.5951).! !

!RungeKuttaStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/15/2013 15:50'!
testVectorSystem
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #StepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!StepperTest commentStamp: '<historical>' prior: 0!
A StepperTest is a test class for testing the behavior of Stepper!

!StepperTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 10:26'!
testOrderIsNilForBaseClass
	self should: [Stepper order isNil].! !

!StepperTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 10:27'!
testOrderIsNilForInstanceOfBaseClass
	self should: [Stepper new order isNil].! !

!StepperTest methodsFor: 'tests' stamp: 'DanielUber 5/22/2012 10:42'!
testSystem
	| stepper sys |
	sys := ExplicitSystem new.
	sys block: [: x :t | t].
	stepper := Stepper onSystem: sys.
	self should: [stepper system = sys].
	sys := ExplicitSystem new.
	self shouldnt: [stepper system = sys].
	! !

TestCase subclass: #TrapezoidSolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!TrapezoidSolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 20:03'!
testSimpleSystem2
	| solver stepper system dt |
	dt := 1.5.
	system := ImplicitSystem block: [:x :t | 3 * (t negated exp) - (0.4 * x)].
	stepper := TrapezoidStepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	
	self should: ((solver solve: system startState: 5 startTime: 0 endTime: 3) closeTo:  2.8977).
       self should: ((solver solve: system startState: 0.1 startTime: 1 endTime: 2.5) closeTo:  0.9103).! !

!TrapezoidSolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 20:01'!
testSimpleSystem3
	| solver stepper system dt |
	dt := 0.5.
	system := ImplicitSystem block: [:x :t | 2 * t * x].
	stepper := TrapezoidStepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [(solver solve: system startState: 1 startTime: 0 endTime: 1.5) closeTo: 9.7551].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 1.5) closeTo: 9.7298].
	self should: [(solver solve: system startState: 0.1 startTime: 1 endTime: 2.5) closeTo: 16.0288].
	self should: [(solver solve: system startState: 1.25 startTime: 0.5 endTime: 2.5) closeTo: 415.6194].! !

!TrapezoidSolverTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/13/2013 11:56'!
testVectorSystem
	
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := TrapezoidStepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !

TestCase subclass: #TrapezoidStepperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-ODE'!

!TrapezoidStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:58'!
testDoStepTime
	"this is identical to testDoStepTimeStepSize except dt is stored."
	| stepper sys dt |
	sys := ImplicitSystem block: [:x :t | x * t].
	stepper := TrapezoidStepper onSystem: sys.
	dt := 0.1.
	stepper stepSize: dt.
	self should: [stepper stepSize = dt].
	self should: [(stepper doStep: 0 time: 10) closeTo: 0 ].
	self should: [(stepper doStep: 10 time: 0 stepSize: 1) closeTo: 17.5 ].

	"stepSize parameter changes the stored stepSize"
	self should: [(stepper stepSize = 1)].

	self should: [(stepper doStep: 1 time:  1) closeTo: 5].
	self should: [(stepper doStep: 10 time:  1 stepSize: 0.2) closeTo: 12.4928].! !

!TrapezoidStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:53'!
testDoStepTimeStepSize1
	| stepper sys dt |
	sys := ImplicitSystem block: [:x :t | x * t].
	stepper := TrapezoidStepper  onSystem: sys.
	dt := 0.1.
	self should: [(stepper doStep: 0 time: 10 stepSize: dt) closeTo:  0.0 ].
	self should: [(stepper doStep: 10 time: 0 stepSize: dt) closeTo:  10.05 ].
	self should: [(stepper doStep: 1 time:  1 stepSize: dt) closeTo: 1.1111].
	self should: [(stepper doStep: 10 time:  1 stepSize: dt) closeTo:  11.11].! !

!TrapezoidStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/17/2013 19:54'!
testDoStepTimeStepSize2
	| stepper sys dt |
	sys := ImplicitSystem block: [:x :t | 3 * t negated exp - (0.4 * x)].
	stepper := TrapezoidStepper  onSystem: sys.
	dt := 0.1.
	self should: [(stepper doStep: 1 time:  1 stepSize: dt)closeTo: 1.0638].
	self should: [(stepper doStep: 10 time:  1 stepSize: dt) closeTo:  9.7109].! !

!TrapezoidStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 7/9/2013 00:09'!
testOrderIsTwo
	self should: [TrapezoidStepper order = 2]! !

!TrapezoidStepperTest methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 8/7/2013 13:51'!
testVectorSystem
	
	| solver stepper system dt |
	dt := 0.01.
	system := ExplicitSystem block: [:x :t | | c | c:= DhbVector new: 2. 
												c at: 1 put: t sin. 
												c at: 2 put: t cos.
												c].
	stepper := TrapezoidStepper onSystem: system.
	solver := (ImplicitSolver new) stepper: stepper; system: system; dt: dt.
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi ) at: 1)closeTo: 1].
	self should: [((solver solve: system startState: #(-1 0) startTime: 0 endTime: Float pi / 2 ) at: 2 ) closeTo: 1].! !
